image: registry.gitlab.com/matilda.peak/doozer:stable

stages:
- package

# To build and push Docker images we
# need to provide the Docker-in-Docker service
# and provide the location of the Docker host.
#
# See https://gitlab.com/gitlab-org/gitlab-runner/issues/2638
services:
- docker:dind
variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2

# Actions prior to every job.
before_script:
- pip install --upgrade pip
- pip install -r requirements.txt

# ####
# Jobs that only run on the master branch (except tag operations)
# ####

# Create and push the `latest` Docker image.
docker latest:
  stage: package
  tags:
  - docker
  script:
  - cd docker
  - docker build -t $CI_REGISTRY_IMAGE:latest .
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker push $CI_REGISTRY_IMAGE
  only:
  - master
  except:
  - tags

# ####
# Jobs that only run on untagged developer branches
# ####

# Create and push a Docker image taqged with the branch name.
docker branch:
  stage: package
  tags:
  - docker
  script:
  - cd docker
  - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG .
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker push $CI_REGISTRY_IMAGE
  except:
  - master
  - tags

# ####
# Jobs that only run on the master branch when tagged
# ####

# Create and push a Docker image taqged with the branch name.
docker stable:
  stage: package
  tags:
  - docker
  script:
  - cd docker
  # Build and push the stable image
  - docker build -t $CI_REGISTRY_IMAGE:stable .
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker push $CI_REGISTRY_IMAGE:stable
  # Tag and push the tagged image
  - docker tag $CI_REGISTRY_IMAGE:stable $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  only:
  - tags
  except:
  - branches
